---
title: XRSessionMode
slug: Web/API/XRSessionMode
tags:
  - API
  - AR
  - Enum
  - Graphics
  - Reference
  - Session
  - Type
  - VR
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRSession
  - XRSessionMode
---
<div>{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API's</a> <strong><code>XRSessionMode</code></strong> enumerated type defines the string values used to identify the possible kinds of session mode that can be used.</span></p>

<h2 id="Values">Values</h2>

<dl>
 <dt><a id="immersive-ar"><code>immersive-ar</code></a> {{experimental_inline}}</dt>
 <dd>
 <p>The session's output will be given exclusive access to the immersive device, but the rendered content will be blended with the real-world environment. The session's {{DOMxRef("XRSession.environmentBlendMode", "environmentBlendMode")}} indicates the method to be used to blend the content together.</p>

 <div class="notecard warning">
 <p><strong>Important:</strong> The <code>immersive-ar</code> mode is defined by the WebXR Augmented Reality Module, which is not yet stable and should not be used other than for testing and experimentation.</p>
 </div>
 </dd>
 <dt><a id="immersive-vr"><code>immersive-vr</code></a></dt>
 <dd>Indicates that the rendered session will be displayed using an immersive XR device in VR mode; it is not intended to be overlaid or integrated into the surrounding environment. The {{DOMxRef("XRSession.environmentBlendMode", "environmentBlendMode")}} is expected to be <code>opaque</code> if possible, but might be <code>additive</code> if the hardware requires it.</dd>
 <dt><a id="inline"><code>inline</code></a></dt>
 <dd>The output is presented inline within the context of an element in a standard HTML document, rather than occupying the full visual space. Inline sessions can be presented in either mono or stereo mode, and may or may not have viewer tracking available. Inline sessions don't require special hardware and should be avalable on any {{Glossary("user agent")}} offering WebXR API support.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The <code>XRSessionMode</code> type indicates the values that can be specified when calling {{domxref("XRSystem.isSessionSupported()")}} to determine whether or not the specified session type is supported and available to be used, and by {{domxref("XRSystem.requestSession", "requestSession()")}} to attempt to open a new WebXR session.</p>

<p>The <code>immersive-ar</code> mode supports all the same features and reference spaces that <code>immersive-vr</code> does, since both are immersive sessions. Browsers may support either or both of these modes, but if WebXR is available, the <code>inline</code> mode is <em>always</em> supported.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrsessionmode-enum","XRSessionMode")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName("WebXR AR Module", "#dom-xrsessionmode-immersive-ar", "XRSessionMode: immersive-ar")}}</td>
   <td>{{Spec2("WebXR AR Module")}}</td>
   <td>The <code>immersive-ar</code> value added</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSessionMode")}}</div>
